freeslot(
	"S_MKNUCKLESDIGDOWN1",
	"S_MKNUCKLESDIGDOWN2",
	"S_MKNUCKLESDIGDOWN3",
	"S_MKNUCKLESDIGDOWN4",
	"S_MKNUCKLESDIGUP1",
	"S_MKNUCKLESDIGUP2",
	"S_MKNUCKLESDIGUP3",
	"S_MKNUCKLESDIGUP4",
	"SPR_MKDA",
	"SPR_MKDB",
	"MT_MKROCKBLAST"
)

states[S_MKNUCKLESDIGDOWN1] = {
	sprite = SPR_MKDA,
	frame = A,
	tics = 1,
	nextstate = S_MKNUCKLESDIGDOWN2
}

states[S_MKNUCKLESDIGDOWN2] = {
	sprite = SPR_MKDA,
	frame = B,
	tics = 1,
	nextstate = S_MKNUCKLESDIGDOWN3
}

states[S_MKNUCKLESDIGDOWN3] = {
	sprite = SPR_MKDA,
	frame = C,
	tics = 1,
	nextstate = S_MKNUCKLESDIGDOWN4
}

states[S_MKNUCKLESDIGDOWN4] = {
	sprite = SPR_MKDA,
	frame = D,
	tics = 1,
	nextstate = S_MKNUCKLESDIGDOWN1
}

states[S_MKNUCKLESDIGUP1] = {
	sprite = SPR_MKDB,
	frame = A,
	tics = 1,
	nextstate = S_MKNUCKLESDIGUP2
}

states[S_MKNUCKLESDIGUP2] = {
	sprite = SPR_MKDB,
	frame = B,
	tics = 1,
	nextstate = S_MKNUCKLESDIGUP3
}

states[S_MKNUCKLESDIGUP3] = {
	sprite = SPR_MKDB,
	frame = C,
	tics = 1,
	nextstate = S_MKNUCKLESDIGUP4
}

states[S_MKNUCKLESDIGUP4] = {
	sprite = SPR_MKDB,
	frame = D,
	tics = 1,
	nextstate = S_MKNUCKLESDIGUP1
}

mobjinfo[MT_MKROCKBLAST] = {
	spawnstate = S_ROCKCRUMBLEA,
	spawnhealth = 1000,
	radius = 8*FRACUNIT,
	height = 16*FRACUNIT,
	mass = 0,
	damage = 0,
	flags = MF_MISSILE|MF_BOUNCE|MF_GRENADEBOUNCE
}

mobjinfo[MT_MKROCKBLAST].name = "rock blast"

local function mkrockblast(player)
	for i = 1, 17
		local rock = P_SpawnPlayerMissile(player.mo, MT_MKROCKBLAST, MF2_SCATTER)
		rock.tics = 100
		rock.frame = A
		P_InstaThrust(rock, i*ANGLE_22h, 5*player.mo.scale)
		rock.momz = 16*P_MobjFlip(player.mo)*player.mo.scale
		rock.eflags = player.mo.eflags & MFE_VERTICALFLIP
	end
end

local function CheckAndCrumble(mo, sec)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    
    if mo.z + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z > fof.topheight continue end -- Are we too high?

    -- Check for whatever else you may want to    

    EV_CrumbleChain(fof) -- Crumble
  end
end

addHook ("PlayerThink",function(player)
local mo = player.mo
if player.mknuxdigcd == nil then player.mknuxdigcd = 0 return end
if mo.skin == "modernknuckles"
and not player.exiting
and P_IsObjectOnGround(mo)
and not (P_PlayerInPain(player) or (player.playerstate == PST_DEAD))
and (player.cmd.buttons & BT_CUSTOM3) and not (player.cmd.buttons & BT_CUSTOM1) and not (player.cmd.buttons & BT_CUSTOM2)
and not player.weapondelay
and not player.dig
and mo.state != S_PLAY_PUNCH1
and mo.state != S_PLAY_ALTPUNCH1
and mo.state != S_PLAY_PUNCHWAIT
and mo.state != S_PLAY_PUNCH2
and mo.state != S_PLAY_ALTPUNCH2
and mo.state != S_ROCKTHROW
and mo.state != S_PLAY_KTAUNT
and not player.powers[pw_carry]
and not player.mkcd2
and not player.actionstate
and not player.hampunch
and not (player.pflags & PF_SLIDING)
and not player.guard
and not player.airdodge

player.dig = true
player.weapondelay = TICRATE*5
S_StartSound(mo,sfx_s3kccs)
player.pflags = $ & ~PF_SPINNING
player.pflags = $ & ~PF_STARTDASH
CheckAndCrumble(mo, mo.subsector.sector)
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and not player.exiting
and not P_IsObjectOnGround(player.mo)
and not (P_PlayerInPain(player) or (player.playerstate == PST_DEAD))
and (player.cmd.buttons & BT_CUSTOM3) and not (player.cmd.buttons & BT_CUSTOM1) and not (player.cmd.buttons & BT_CUSTOM2)
and not player.weapondelay
and not player.digland
and not (player.pflags & PF_THOKKED)
and player.mo.state != S_PLAY_CLIMB
and player.mo.state != S_PLAY_CLING
and player.mo.state != S_PLAY_RIDE
and player.mo.state != S_PLAY_UPPERCUT
and not player.mkcd2
and not player.actionstate
and not player.hampunch
and not player.guard
and not player.airdodge

player.digland = true
P_SetObjectMomZ(player.mo,-55*FRACUNIT,true)
S_StartSound(player.mo, sfx_zoom)
player.mo.state = S_MKNUCKLESDIGDOWN1
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and not player.exiting
and not P_IsObjectOnGround(player.mo)
and not (P_PlayerInPain(player) or (player.playerstate == PST_DEAD))
and (player.cmd.buttons & BT_CUSTOM3) and not (player.cmd.buttons & BT_CUSTOM1) and not (player.cmd.buttons & BT_CUSTOM2)
and not player.weapondelay
and not player.digland
and player.mo.state != S_PLAY_CLIMB
and player.mo.state != S_PLAY_CLING
and player.mo.state != S_PLAY_RIDE
and (player.pflags & PF_GLIDING)
and not player.mkcd2
and not player.actionstate
and not player.hampunch
and not player.guard
and not player.airdodge

player.digland = true
P_SetObjectMomZ(player.mo,-55*FRACUNIT,true)
S_StartSound(player.mo, sfx_zoom)
player.pflags = $ & ~PF_GLIDING
player.mo.state = S_MKNUCKLESDIGDOWN1
player.pflags = $|PF_JUMPED
end
end)

addHook ("PlayerThink",function(player)
local mo = player.mo
if mo.skin == "modernknuckles"
and not player.exiting
and P_IsObjectOnGround(mo)
and player.digland == true
and not player.dig

player.digland = false
player.dig = true
player.weapondelay = TICRATE*5
S_StartSound(mo,sfx_s3kccs)
player.pflags = $ & ~PF_SPINNING
player.pflags = $ & ~PF_STARTDASH
CheckAndCrumble(mo, mo.subsector.sector)
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.dig == true
and player.weapondelay

player.jumpfactor = 0*FRACUNIT
player.charability2 = CA2_NONE
player.charflags = $ | SF_NOSKID
player.normalspeed = 24*FRACUNIT
player.mo.flags = $|MF_NOCLIPTHING
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.dig == true
and player.mo.state == S_PLAY_STND

player.mo.state = S_KNUXDIGA
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.dig == true
and player.mo.state == S_PLAY_SKID

player.mo.state = S_KNUXDIGA
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.dig == true
and player.mo.state == S_PLAY_WAIT

player.mo.state = S_KNUXDIGA
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.dig == true
and player.mo.state == S_PLAY_EDGE

player.mo.state = S_KNUXDIGA
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.dig == true
and player.mo.state == S_PLAY_ROLL

player.mo.state = S_KNUXDIGA
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.dig == true
and player.mo.state == S_PLAY_SPINDASH

player.mo.state = S_KNUXDIGA
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.dig == true
and player.mo.state == S_PLAY_WALK

player.mo.state = S_KNUXDIGA
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.dig == true
and player.mo.state == S_PLAY_RUN

player.mo.state = S_KNUXDIGA
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.dig == true
and player.mo.state == S_PLAY_GLIDE

player.mo.state = S_KNUXDIGA
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.dig == true
and player.mo.state == S_PLAY_GLIDE_LANDING

player.mo.state = S_KNUXDIGA
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.dig == true
and not player.weapondelay
and not (player.pflags & PF_THOKKED)

player.mo.state = S_PLAY_SPRING
player.jumpfactor = 17*FRACUNIT/20
player.dig = false
player.digland = false
player.pflags = $|PF_JUMPED
P_SetObjectMomZ(player.mo,8*FRACUNIT,true)
player.pflags = $|PF_THOKKED
S_StartSound(player.mo,sfx_s3k82)
player.charability2 = CA2_SPINDASH
player.charflags = $ & ~SF_NOSKID
player.normalspeed = 31*FRACUNIT
player.mo.flags = $ & ~MF_NOCLIPTHING
player.charflags = $ & ~SF_MULTIABILITY
player.mkcd2 = true
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.dig == true
and player.weapondelay
and player.cmd.buttons & BT_JUMP
and not (player.pflags & PF_THOKKED)
and not player.mkjmp

player.mo.state = S_MKNUCKLESDIGUP1
player.jumpfactor = 17*FRACUNIT/20
player.dig = false
player.digland = false
player.pflags = $|PF_JUMPED
P_SetObjectMomZ(player.mo,8*FRACUNIT,true)
player.weapondelay = TICRATE*0
player.pflags = $|PF_THOKKED
S_StartSound(player.mo,sfx_s3k82)
player.charability2 = CA2_SPINDASH
player.charflags = $ & ~SF_NOSKID
player.mo.flags = $ & ~MF_NOCLIPTHING
player.normalspeed = 31*FRACUNIT
player.charflags = $ & ~SF_MULTIABILITY
mkrockblast(player)
player.mkcd2 = true
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.dig == true
and player.weapondelay
and player.cmd.buttons & BT_SPIN
and not (player.pflags & PF_THOKKED)
and not player.mkjmp

player.mo.state = S_MKNUCKLESDIGUP1
player.jumpfactor = 17*FRACUNIT/20
player.dig = false
player.digland = false
player.pflags = $|PF_JUMPED
P_SetObjectMomZ(player.mo,8*FRACUNIT,true)
player.weapondelay = TICRATE*0
player.pflags = $|PF_THOKKED
S_StartSound(player.mo,sfx_s3k82)
player.charability2 = CA2_SPINDASH
player.charflags = $ & ~SF_NOSKID
player.mo.flags = $ & ~MF_NOCLIPTHING
player.normalspeed = 31*FRACUNIT
player.charflags = $ & ~SF_MULTIABILITY
player.mkcd2 = true
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.dig == true
and player.weapondelay
and not P_IsObjectOnGround(player.mo)
and not P_PlayerInPain(player)
and player.health == 1

player.mo.state = S_MKNUCKLESDIGUP1
player.jumpfactor = 17*FRACUNIT/20
player.dig = false
player.digland = false
player.pflags = $|PF_JUMPED
P_SetObjectMomZ(player.mo,8*FRACUNIT,true)
player.weapondelay = TICRATE*0
player.pflags = $|PF_THOKKED
S_StartSound(player.mo,sfx_s3k82)
player.charability2 = CA2_SPINDASH
player.charflags = $ & ~SF_NOSKID
player.mo.flags = $ & ~MF_NOCLIPTHING
player.normalspeed = 31*FRACUNIT
player.charflags = $ & ~SF_MULTIABILITY
player.mkcd2 = true
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.dig == true
and player.weapondelay
and player.powers[pw_carry]

player.mo.state = S_MKNUCKLESDIGUP1
player.jumpfactor = 17*FRACUNIT/20
player.dig = false
player.digland = false
player.pflags = $|PF_JUMPED
P_SetObjectMomZ(player.mo,8*FRACUNIT,true)
player.weapondelay = TICRATE*0
player.pflags = $|PF_THOKKED
S_StartSound(player.mo,sfx_s3k82)
player.charability2 = CA2_SPINDASH
player.charflags = $ & ~SF_NOSKID
player.mo.flags = $ & ~MF_NOCLIPTHING
player.normalspeed = 31*FRACUNIT
player.charflags = $ & ~SF_MULTIABILITY
player.mkcd2 = true
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.powers[pw_justsprung]
and player.digland == true

player.mo.state = S_PLAY_SPRING
player.dig = false
player.digland = false
player.powers[pw_justsprung] = 0
player.jumpfactor = 17*FRACUNIT/20
player.weapondelay = TICRATE*0
player.pflags = $|PF_THOKKED
player.charability2 = CA2_SPINDASH
player.charflags = $ & ~SF_NOSKID
player.mo.flags = $ & ~MF_NOCLIPTHING
player.normalspeed = 31*FRACUNIT
player.mkcd2 = true
P_SetObjectMomZ(player.mo,5*FRACUNIT,true)
S_StartSound(mobj, sfx_sprong)
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.digland == true
and P_PlayerInPain(player)

player.jumpfactor = 17*FRACUNIT/20
player.dig = false
player.digland = false
player.charability2 = CA2_SPINDASH
player.charflags = $ & ~SF_NOSKID
player.normalspeed = 31*FRACUNIT
player.charflags = $ & ~SF_MULTIABILITY
player.mkcd2 = true
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.digland == true
and player.playerstate == PST_DEAD

player.jumpfactor = 17*FRACUNIT/20
player.dig = false
player.digland = false
player.charability2 = CA2_SPINDASH
player.charflags = $ & ~SF_NOSKID
player.normalspeed = 31*FRACUNIT
player.charflags = $ & ~SF_MULTIABILITY
player.mkcd2 = true
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.digland == true
and (player.mo.momz > (9000*P_MobjFlip(player.mo)))
				
P_SetObjectMomZ(player.mo, FixedMul(-55*FRACUNIT, player.mo.scale))
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.cmd.buttons & BT_JUMP

player.mkjmp = true
else
player.mkjmp = false
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.dig

player.height = 8*FRACUNIT
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and not player.dig

player.height = 48*FRACUNIT
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.mkcd2
and not (leveltime%35)

player.mknuxdigcd = $+1
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.mkcd2
and player.mknuxdigcd == 5

player.mknuxdigcd = 0
player.mkcd2 = false
S_StartSound(player.mo, sfx_s3k8c)
end
end)

addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	if target.player and target.player.dig and inflictor and target.skin == "modernknuckles"
		return true
	end
end, MT_PLAYER)